## libzdnn 0.4.0

=== Makefile ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright IBM Corp. 2021
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

THIRDPARTY_ROOT = third_party
UNITY_ROOT = $(THIRDPARTY_ROOT)/Unity

OBJDIR := obj
BINDIR := bin

_dummy := $(shell mkdir -p $(OBJDIR); mkdir -p $(BINDIR))

include ../config.make

INCDIR := $(CFLAGS_NOSEARCH) -I ../zdnn -I $(UNITY_ROOT)/src

ifneq ($(CC),xlc)
ifneq ($(no_rpath),1)
LDFLAGS := $(LDFLAGS) -Wl,-rpath=\$$ORIGIN/../../zdnn/${SODIR}
endif
endif

C_TEST_SUPPORTFILES := $(UNITY_ROOT)/src/unity.c testsupport.c $(wildcard common_*.c)
CXX_TEST_SUPPORTFILES := $(wildcard *.cpp)
TEST_FILES := $(wildcard testDriver*.c)

C_TEST_SUPPORTOBJ := $(patsubst %.c,$(OBJDIR)/%.o,$(notdir $(C_TEST_SUPPORTFILES)))
CXX_TEST_SUPPORTOBJ := $(patsubst %.cpp,$(OBJDIR)/%.o,$(notdir $(CXX_TEST_SUPPORTFILES)))
TEST_OBJ        := $(patsubst %.c,$(OBJDIR)/%.o,$(TEST_FILES))
TEST_BINARIES   := $(patsubst %.c,$(BINDIR)/%,$(TEST_FILES))
TEST_RESULTS    := $(patsubst %.c,$(BINDIR)/%.txt,$(TEST_FILES))

PARSED_RESULT:= `python3 resources/testresult_parser.py`

all: test

.PHONY: test

test: $(TEST_RESULTS) $(TEST_BINARIES) $(TEST_OBJ) $(C_TEST_SUPPORTOBJ) $(CXX_TEST_SUPPORTOBJ)
	@echo $(ECHOFLAGS) ${PARSED_RESULT}

# Compile
$(OBJDIR)/%.o: $(UNITY_ROOT)/src/%.c
	$(CC) $(INCDIR) $(CFLAGS) -c -o $@ $<

$(OBJDIR)/%.o: $(ARGTABLE3_ROOT)/src/%.c
	$(CC) $(INCDIR) $(CFLAGS) -c -o $@ $<

$(OBJDIR)/%.o: %.c
	$(CC) $(INCDIR) $(CFLAGS) -c -o $@ $<

$(OBJDIR)/%.o: %.cpp
	$(CXX) $(INCDIR) $(CXXFLAGS) -c -o $@ $<

# Link
$(BINDIR)/testDriver_%: $(OBJDIR)/testDriver_%.o $(C_TEST_SUPPORTOBJ) $(CXX_TEST_SUPPORTOBJ)
	$(CXX) $(INCDIR) $(CXXFLAGS) -o $@ $< $(C_TEST_SUPPORTOBJ) $(CXX_TEST_SUPPORTOBJ) $(LDFLAGS) $(LDFLAGS_TEST)

# Run testcase
$(BINDIR)/%.txt: $(BINDIR)/%
	-$(LD_PATH_VAR)=../zdnn/$(SODIR) ZDNN_LOGLEVEL=off ./$< > $@

.PHONY: clean

clean:
	$(RM) $(OBJDIR)/* *~ core
	$(RM) $(BINDIR)/* *~ core

=== debian/changelog ===
libzdnn (0.4.0-0ubuntu1) jammy; urgency=medium

  * Initial release v0.4.0 (LP: #1959396)

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 08 Feb 2022 19:54:55 +0100

=== debian/control ===
Source: libzdnn
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Frank Heimes <frank.heimes@canonical.com>
Build-Depends:
 debhelper-compat (= 13),
Rules-Requires-Root: no
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/IBM/zDNN

Package: libzdnn-dev
Section: libdevel
Architecture: s390x
Multi-Arch: same
Depends:
 libzdnn0 (= ${binary:Version}),
 ${misc:Depends},
Description: IBM Z Deep Neural Network Library (zDNN) (development)
 IBM Z Deep Neural Network Library (zDNN) provides an
 interface for applications making use of
 Neural Network Processing Assist Facility (NNPA).
 This package provides development headers.

Package: libzdnn0
Architecture: s390x
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: IBM Z Deep Neural Network Library (zDNN)
 IBM Z Deep Neural Network Library (zDNN) provides an
 interface for applications making use of
 Neural Network Processing Assist Facility (NNPA).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ # make

override_dh_auto_build:
	# to avoid 'make' or 'make all', that incl. 'test' which does not work
	dh_auto_build -- build

override_dh_auto_test:
	# skipping test, due to lack of availability of 'unity' unit test framework

override_dh_auto_clean:
	# avoid failing clean in a clean or unconfigured environment
	if [ -f config.make ]; then dh_auto_clean; fi

## libzdnn 1.0.1

=== Makefile ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright IBM Corp. 2021
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

.DEFAULT_GOAL := all

.PHONY: all
all: config.make
	$(MAKE) all -C zdnn
	$(MAKE) all -C tests

.PHONY: help
help:
	@echo "Available targets:"
	@egrep '^[a-z]+:' Makefile | cut -d: -f1 | sort | xargs -n 1 echo "    "

.PHONY: build
build: config.make
	$(MAKE) all -C zdnn

.PHONY: test
test: config.make
	$(MAKE) all -C tests

.PHONY: clean
clean: config.make
	$(MAKE) clean -C tests
	$(MAKE) clean -C zdnn

.PHONY: distclean
distclean: clean
	rm -f config.log config.status config.make config.h


.PHONY: install
install: build
	$(MAKE) install -C zdnn

config.make:
# Use this additional check to allow make invocation "make -B build" in jenkins.
ifeq ($(wildcard config.make),)
	$(error "Please use configure first")
endif

=== tests/Makefile ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright IBM Corp. 2021
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

THIRDPARTY_ROOT = third_party
UNITY_ROOT = $(THIRDPARTY_ROOT)/Unity

OBJDIR := obj
BINDIR := bin

_dummy := $(shell mkdir -p $(OBJDIR); mkdir -p $(BINDIR))

include ../config.make

INCDIR := $(CFLAGS_NOSEARCH) -I ../zdnn -I $(UNITY_ROOT)/src

ifneq ($(CC),xlc)
ifneq ($(no_rpath),1)
LDFLAGS := $(LDFLAGS) -Wl,-rpath=\$$ORIGIN/../../zdnn/${SODIR}
endif
endif

C_TEST_SUPPORTFILES := $(UNITY_ROOT)/src/unity.c testsupport.c $(wildcard common_*.c)
CXX_TEST_SUPPORTFILES := $(wildcard *.cpp)
TEST_FILES := $(wildcard testDriver*.c)

C_TEST_SUPPORTOBJ := $(patsubst %.c,$(OBJDIR)/%.o,$(notdir $(C_TEST_SUPPORTFILES)))
CXX_TEST_SUPPORTOBJ := $(patsubst %.cpp,$(OBJDIR)/%.o,$(notdir $(CXX_TEST_SUPPORTFILES)))
TEST_OBJ        := $(patsubst %.c,$(OBJDIR)/%.o,$(TEST_FILES))
TEST_BINARIES   := $(patsubst %.c,$(BINDIR)/%,$(TEST_FILES))
TEST_RESULTS    := $(patsubst %.c,$(BINDIR)/%.txt,$(TEST_FILES))

PARSED_RESULT:= `python3 resources/testresult_parser.py`

all: test

.PHONY: test

test: $(TEST_RESULTS) $(TEST_BINARIES) $(TEST_OBJ) $(C_TEST_SUPPORTOBJ) $(CXX_TEST_SUPPORTOBJ)
	@echo $(ECHOFLAGS) ${PARSED_RESULT}

# Compile
$(OBJDIR)/%.o: $(UNITY_ROOT)/src/%.c
	$(CC) $(INCDIR) $(CFLAGS) -c -o $@ $<

$(OBJDIR)/%.o: $(ARGTABLE3_ROOT)/src/%.c
	$(CC) $(INCDIR) $(CFLAGS) -c -o $@ $<

$(OBJDIR)/%.o: %.c
	$(CC) $(INCDIR) $(CFLAGS) -c -o $@ $<

$(OBJDIR)/%.o: %.cpp
	$(CXX) $(INCDIR) $(CXXFLAGS) -c -o $@ $<

# Link
$(BINDIR)/testDriver_%: $(OBJDIR)/testDriver_%.o $(C_TEST_SUPPORTOBJ) $(CXX_TEST_SUPPORTOBJ)
	$(CXX) $(INCDIR) $(CXXFLAGS) -o $@ $< $(C_TEST_SUPPORTOBJ) $(CXX_TEST_SUPPORTOBJ) $(LDFLAGS) $(LDFLAGS_TEST)

# Run testcase
$(BINDIR)/%.txt: $(BINDIR)/%
	-$(LD_PATH_VAR)=../zdnn/$(SODIR) ZDNN_LOGLEVEL=off ./$< > $@

.PHONY: clean

clean:
	$(RM) $(OBJDIR)/* *~ core
	$(RM) $(BINDIR)/* *~ core

=== zdnn/Makefile ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright IBM Corp. 2021
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

_dummy := $(shell mkdir -p obj)
OBJDIR := obj

include ../config.make

INCDIR := $(CFLAGS_NOSEARCH) -I ../zdnn -I .

_dummy2 := $(shell mkdir -p $(SODIR))

CFLAGS := $(INCDIR) $(CFLAGS)
CXXFLAGS := $(INCDIR) $(CXXFLAGS)

H_FILES        := $(filter-out $(wildcard convert*.h), $(wildcard *.h))
INIT_SRCFILE := zdnn_init.c
SRCFILES     := $(filter-out $(INIT_SRCFILE), $(wildcard *.c) $(wildcard *.cpp))

# Add the configure generated header
H_FILES += ../config.h

OBJFILES          := $(patsubst %.c,$(OBJDIR)/%.o,$(patsubst %.cpp,$(OBJDIR)/%.o,$(SRCFILES)))
INIT_OBJFILE      := $(patsubst %.c,$(OBJDIR)/%.o,$(INIT_SRCFILE))

all: $(SODIR)/$(LIBNAME).so $(SODIR)/$(LIBNAME_PRIVATE).so $(ZDNN_MAKE_TARGETS)

$(INIT_OBJFILE): $(INIT_SRCFILE)
	$(CC) $(CFLAGS_INIT) $(CFLAGS_SHARED) -c $< -o $@

$(OBJDIR)/%.o: %.c
	$(CC) $(CFLAGS) $(CFLAGS_SHARED) -c $< -o $@

$(OBJDIR)/%.o: %.cpp
	$(CXX) $(CXXFLAGS) $(CFLAGS_SHARED) -c $< -o $@

include $(ZDNN_TMAKE_FILES)


$(SODIR)/$(LIBNAME).so: $(INIT_OBJFILE) $(OBJFILES) $(H_FILES)
	$(LD) $(LDFLAGS_SHARED) -o $(SODIR)/$(LIBNAME).so $(INIT_OBJFILE) $(OBJFILES)

.PHONY: clean

clean:
	$(RM) $(OBJDIR)/*.o $(OBJDIR)/*.lst $(OBJDIR)/*.d *~ core $(SODIR)/* \
	*.so* ../zdnn/zdnn_private.map \
	zdnn.i zdnn.dynsyms symcheck

.PHONY: install

install: all install_shared $(ZDNN_INSTALL_TARGETS)

.PHONY: install_shared

install_shared:
	$(INSTALL) -d $(DESTDIR)$(libdir)
	$(INSTALL) -d $(DESTDIR)$(includedir)
	$(INSTALL) -t $(DESTDIR)$(libdir) $(SODIR)/$(LIBNAME).so
	$(INSTALL_DATA) -t $(DESTDIR)$(includedir) zdnn.h

=== debian/changelog ===
libzdnn (1.0.1-0ubuntu1) lunar; urgency=medium

  * New upstream release (LP: #2007175)
  * Updated 'Standards-Version' in d/control to latest 4.6.1.0.

 -- Frank Heimes <frank.heimes@canonical.com>  Mon, 13 Feb 2023 19:42:44 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1.0
 Section: libs
 Homepage: https://github.com/IBM/zDNN

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libzdnn-$1.tar.gz%" \
    https://github.com/IBM/zDNN/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libzdnn 1.1.1

=== Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 .PHONY: help
 help:
 	@echo "Available targets:"
-	@egrep '^[a-z]+:' Makefile | cut -d: -f1 | sort | xargs -n 1 echo "    "
+	@egrep "^[a-z]+:" Makefile | cut -d':' -f1 | sort | xargs -n 1 echo "    "
 
 .PHONY: build
 build: config.make

=== tests/Makefile ===
--- 
+++ 
@@ -1,13 +1,13 @@
 # SPDX-License-Identifier: Apache-2.0
 #
 # Copyright IBM Corp. 2021
-#
+# 
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at
-#
+# 
 #     http://www.apache.org/licenses/LICENSE-2.0
-#
+# 
 # Unless required by applicable law or agreed to in writing, software
 # distributed under the License is distributed on an "AS IS" BASIS,
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@@ -15,7 +15,7 @@
 # limitations under the License.
 
 THIRDPARTY_ROOT = third_party
-UNITY_ROOT = $(THIRDPARTY_ROOT)/Unity
+UNITY_ROOT ?= $(THIRDPARTY_ROOT)/Unity
 
 OBJDIR := obj
 BINDIR := bin

=== debian/changelog ===
libzdnn (1.1.1-0ubuntu1) plucky; urgency=medium

  * New upstream release (LP: #2095373)
  * Expand d/libzdnn0.symbols with new/additional symbols.
  * Bump Standards-Version field in d/control to latest level 4.7.0.

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 21 Jan 2025 14:33:08 +0100

libzdnn (1.0.1-0ubuntu2) oracular-proposed; urgency=medium

  * LP: #2076340: No-change rebuild to pick up changed build flags on
    ppc64el and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 08 Aug 2024 14:55:48 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.6.1.0
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://github.com/IBM/zDNN

## libzdnn 1.1.2

=== debian/changelog ===
libzdnn (1.1.2-0ubuntu1) questing; urgency=medium

  * New upstream release. (LP: #2116713)
    - No symbols update required.
    - Bump Standards-Version field in d/control to latest level 4.7.2.

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 15 Jul 2025 11:49:55 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/IBM/zDNN
